#!/bin/bash

a=4
b=5

#  Ici, "a" et "b" peuvent être soit des entiers, soit des
#+ chaînes de caractères.
#  Il y a un certain flou entre comparaisons arithmétiques et
#+ comparaisons de chaînes car les variables Bash ne sont pas 
#+ fortement typées.

#  Bash permet les opérations prévues pour les entiers, et les
#  comparaisons, sur les variables qui contiennent uniquement des
#  caractères numériques. Néanmoins, il convient d'être prudent.

echo

if [ "$a" -ne "$b" ]
then
  echo "$a n'est pas égal à $b"
  echo "(comparaison arithmétique)"
fi

echo

if [ "$a" != "$b" ]
then
  echo "$a n'est pas égal à $b."
  echo "(comparaison de chaînes de caractères)"
  #     "4"  != "5"
  # ASCII 52 != ASCII 53
fi

# Dans ce cas précis, "-ne" et "!=" fonctionnent tous les deux.

echo

exit 0
